; *******************************************************************
; EDU10 Lesson 3 - "Rotate"
;
; Extends Lesson 2 to sequence through the LEDs.
;
; *******************************************************************
; * For more details see Microchip's 44-pin Demo Board User's Guide *
; * Chapter 3. 44-Pin Demo Board Lessons                            *
; * http://ww1.microchip.com/downloads/en/DeviceDoc/41296B.pdf      *
; *******************************************************************

#include <p16F882.inc>
	__CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	__CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

     cblock 0x20
Delay1           ; Assign an address to label Delay1
Delay2
Display          ; define a variable to hold the display
     endc
     
     org 0
Start:
     bsf       STATUS,RP0     ; select Register Bank 1
     clrf      TRISC          ; make IO PortB all output
     bcf       STATUS,RP0     ; back to Register Bank 0
     movlw     0x80
     movwf     Display
MainLoop:
     movf      Display,w      ; Copy the display to the LEDs
     movwf     PORTC
OndelayLoop:
     decfsz    Delay1,f       ; Waste time.  
     goto      OndelayLoop    ; The Inner loop takes 3 instructions per loop * 256 loopss = 768 instructions
     decfsz    Delay2,f       ; The outer loop takes and additional 3 instructions per lap * 256 loops
     goto      OndelayLoop    ; (768+3) * 256 = 197376 instructions / 1M instructions per second = 0.197 sec.
                              ; call it two-tenths of a second.	
     
     bcf       STATUS,C       ; ensure the carry bit is clear
     rrf       Display,f
     btfsc     Display,3      ; Did the bit rotate into bit 3?
     goto	   MoveIt      	; yes, move it to bit 7
     goto      MainLoop
MoveIt:
	 bcf       Display,3
	 bsf       Display,7		
     goto      MainLoop

     end
     
