; *******************************************************************
; EDU10 Lesson 14 - "Thermostat"
;
; This shows how to read the voltage on the NTC with the Analog-to-Digital converter.
; The NTC1 on the EDU10 board varies the voltage coming in on RA0. 
; The potentiometer RV1 on the EDU10 board varies the voltage coming in on RA2.
; If the voltage from the NTC1 is higher than the voltage from the potentiometer RV1 the LED LD7 is lit.
; *******************************************************************

#include <p16F882.inc>
	__CONFIG    _CONFIG1, _LVP_OFF & _FCMEN_OFF & _IESO_OFF & _BOR_OFF & _CPD_OFF & _CP_OFF & _MCLRE_ON & _PWRTE_ON & _WDT_OFF & _INTRC_OSC_NOCLKOUT
	__CONFIG    _CONFIG2, _WRT_OFF & _BOR21V

	cblock     0x20
tmp
	endc
     
	org 0x00
	goto	Start
Start:
	bsf     STATUS,RP0       		; select Register Bank 1
	movlw   B'11111111'
	movwf   TRISA            		; Make PORTA all input 
	clrf    TRISC               	; Make PORTC all output
	bsf		STATUS,RP1     			; select Register Bank 3
	movlw	b'00000111'    			; we want 0-2 PORTA pins Analog
	movwf	ANSEL
	bcf		STATUS,RP0     			; back to Register Bank 0
	bcf		STATUS,RP1
	clrf	PORTC            		; PORTC LEDs all off
	clrf	ADCON1					; Analog-to-Digital Left justified, Voltage Reference VDD-VSS
	movlw	b'01000001'
	movwf	ADCON0         			; configure Analog-to-Digital for Fosc/8 and turn on the Analog-to-Digital module

MainLoop:
;								; Check NTC
	movlw	b'01000001'
	movwf	ADCON0         		; Analog-to-Digital Channel 0 (RA0), input from NTC
	call	Delay 				; Acquisition delay 8us
	bsf		ADCON0,GO_DONE 		; start conversion
	btfsc	ADCON0,GO_DONE 		; this bit will change to zero when the conversion is complete
	goto	$-1
	movf	ADRESH,w 
	movwf	tmp
;								; Check potentiometer
	movlw	b'01001001'
	movwf	ADCON0         		; Analog-to-Digital Channel 2 (RA2), input from  RV1
	call	Delay 				; Acquisition delay 8us
	bsf		ADCON0,GO_DONE 		; start conversion
	btfsc	ADCON0,GO_DONE 		; this bit will change to zero when the conversion is complete
	goto	$-1
	movf	ADRESH,w 
	subwf	tmp,w
	btfsc	STATUS,C
	goto	LED_on
	bcf		PORTC,7
	goto    MainLoop
LED_on
	bsf		PORTC,7
	goto    MainLoop

Delay 							; Delay 8us
	nop
	nop
	nop 
	return	
		

    end
